/*******************************************************************
 * protsupp.h, definitions needed to access routines in protsupp.c *
 * Include this file to your protocol implementation.              *
 *******************************************************************/

/* Routines in protsupp.c */

extern int OpenUpSerial(), OpenUpTimer(), getserdata(), getserchar();
extern int sendserdata(), sendserchar();
extern void Scleanup(), Tcleanup();
extern int SetupWindow(), CheckAbort();
extern void Wcleanup(), PText();

/* Global variables that may be needed from within the implementation, too */ 

extern struct IOExtSer *RR, *WR;
extern struct timerequest *TR;
extern struct Window *pwin;

/* Magical numbers when performing resource deallocation */

#define SC_NONE 0    /* Use this when calling Scleanup() */
#define TC_NONE 0    /* Use this when calling Tcleanup() */
#define WC_NONE 0    /* Use this when calling Wcleanup() */
#define GS_TIMEOUT 1 /* Codes returned by getserdata() and getserchar() */
#define GS_NONE 0

/* Pass a structure like this to SetupWindow() */

struct windef {
  UWORD Width, Height; /* Size of the protocol window */
  UWORD GXpos, GYpos;  /* Gadget X and Y position within the window */
  char *Title;         /* Window title */
  char **Text;         /* Ptr to an array of strings to print in the window */
};
