/*********************************************************************
 *  a terminal program that has ascii and xmodem transfer capability
 *
 *	v2.85	    NG	- installed on top of v2.8
 *	v2.65		NG  - tek4014 emulation added
 *	v2.6 870227 DBW - bug fixes for all the stuff in v2.5
 *	v2.5 870214 DBW - more additions (see readme file)
 *	v2.4 861214 DBW - lots of fixes/additions (see readme file)
 *	v2.3 861101 DBW - minor bug fixes
 *	v2.2 861012 DBW - more of the same
 *	v2.1 860915 DBW - new features (see README)
 *	     860823 DBW - Integrated and rewrote lots of code
 *	v2.0 860809 DBW - Major release.. LOTS of changes
 *	v1.1 860720 DBW - Switches, 80 cols, colors, bug fixes
 *	v1.0 860712 DBW - First version released
 *
 *  use esc to abort xmodem transfer
 *
 *  written by Michael Mounier
 *  new version by Dave Wecker 860621
 ********************************************************************/

/*********************** tek defaults *******************************/
extern int t_scale; /* 0->1024x780	1->640x400 resolution		*/
extern int t_on; /* 0 = no  1 = yes  come up with tek screen on */
extern int t_depth; /* depth of tek screen						*/
extern int t_interlace; /* interlace tek screen  0=no  1=yes		*/
extern int t_font_size; /* size of topaz font used by tek window       */

extern int Tek_screen_open;
extern int TekMode;
extern int Tek();
extern int OpenTek();
extern int CloseTek();
extern int InitTekDev();
extern void InitTekItems();
extern void InitTekMenu();
extern void t_cmd_scale();
extern void t_cmd_depth();
extern void t_cmd_on();
extern void t_cmd_interlace();
extern void t_cmd_font_size();

extern struct GfxBase *GfxBase;
extern struct IntuitionBase *IntuitionBase;

#define TekParamsMax 3
#define TekScaleMax 2
#define TekDepthMax 4
#define TekInterlaceMax 2
#define TekScreenMax 5
#define TekSelectMax 2


#define ALPHA	    001
#define LINE	    002
#define MOVE	    004
#define POINT	    010
#define INCREMENTAL 020

#define COLORSET 1024

#define BEL 007
#define BS  010
#define HT  011
#define LF  012
#define VT  013
#define FF  014
#define CR  015
#define CAN 030
#define ESC 033
#define FS  034
#define GS  035
#define RS  036
#define US  037

